/**
 *  STEvent.java
 *
 *  $Log:$
 */
package org.servicetango.core;

import java.beans.*;

/**
 *  Base class for all ST events
 *
 *  @author     ted stockwell [emorning@mediaone.net]
 *  @version    $Revision$
 */
public class STEvent
extends PropertyChangeEvent
{
    boolean m_rollback;
    Object[] m_args= null;

    /**
     * Creates an event class that represents an action
     */
    public STEvent(Object source, String propertyName) {
        this(source, propertyName, null, null, false);
    }
    /**
     * Creates an event class that represents an action
     */
    public STEvent(Object source, String propertyName, boolean rollback) {
        this(source, propertyName, null, null, rollback);
    }
    /**
     * Creates an event class that represents an action
     */
    public STEvent(Object source, String propertyName, Object[] args) {
        this(source, propertyName, args, false);
    }
    /**
     * Creates an event class that represents an action
     */
    public STEvent(Object source, String propertyName, Object[] args, boolean rollback) {
        this(source, propertyName, null, null, rollback);
        m_args= args;
    }


    public STEvent(Object source, String propertyName, Object oldValue, Object newValue) {
        this(source, propertyName, oldValue, newValue, false);
        m_rollback= false;
    }
    public STEvent(Object source, String propertyName, Object oldValue, Object newValue, boolean rollback) {
        super(source, propertyName, oldValue, newValue);
        m_rollback= rollback;
    }

    public boolean isRollback() {
        return m_rollback;
    }
    protected void setRollback(boolean value) {
        m_rollback= value;
    }
    public Object[] getArgs() {
        return m_args;
    }
}
