/**
 *  STException.java
 *
 *  $Log:$
 */
package org.servicetango.core;

import org.osgi.framework.*;
import java.io.*;

/**
 *  Base class for all BundleExceptions that are specific to ServiceTango
 *
 *  @author     ted stockwell [emorning@mediaone.net]
 *  @version    $Revision$
 */
public class STException
extends BundleException
implements Serializable
{
    /**
     *  Constructs an <code>Exception</code> with no specified detail
     *  message.
     */
    public STException() {
	    super("");
    }

    /**
     *  Constructs an <code>Exception</code> with the specified detail
     *  message.
     *
     *  @param   s   the detail message.
     */
    public STException(String s) {
	    super(s);
    }

    public Throwable detail;

    public STException(String s, Throwable ex) {
	super(s);
	detail = ex;
    }
    public STException(Throwable ex) {
        super("");
	detail = ex;
    }

    public String getMessage() {
	if (detail == null)
	    return super.getMessage();
	else
	    return super.getMessage() +
		"; nested exception is: \n\t" +
		detail.toString();
    }

    public void printStackTrace(java.io.PrintStream ps)
    {
	if (detail == null) {
	    super.printStackTrace(ps);
	} else {
	    synchronized(ps) {
		ps.println(this);
		detail.printStackTrace(ps);
	    }
	}
    }

    public void printStackTrace()
    {
	printStackTrace(System.err);
    }

    public void printStackTrace(java.io.PrintWriter pw)
    {
	if (detail == null) {
	    super.printStackTrace(pw);
	} else {
	    synchronized(pw) {
		pw.println(this);
		detail.printStackTrace(pw);
	    }
	}
    }
}
