/*
   STSecurityManager.java

   Copyright (C) 2000 by ted stockwell
   All Rights Reserved.
 */
package org.servicetango.core;

import java.security.*;
import java.io.*;
import java.net.*;


/**
A default security manager that grants all permissions.
This security manager is used by a BundleManager if no other Security Manager
has been installed by the time the BundlManager is instantiated.

This class will be improved in the future to something more appropriate than
just granting everybody the permission to do whatever the hell they want.
I'm thinking that Security for bundles should work like security for servlets
in the Tomcat server but I need more time to research that works...

author  ted stockwell
*/
public class STSecurityManager
extends SecurityManager
{
    /**
     * Tests if there is a security check in progress.
     *
     * @return the value of the <code>inCheck</code> field. This field
     *          should contain <code>true</code> if a security check is
     *          in progress,
     *          <code>false</code> otherwise.
     * @see     java.lang.SecurityManager#inCheck
     * @deprecated This type of security checking is not recommended.
     *  It is recommended that the <code>checkPermission</code>
     *  call be used instead.
     */
    public boolean getInCheck() { return false; }

    public STSecurityManager() { }

    public void checkPermission(Permission perm) { }
    public void checkPermission(Permission perm, Object context) { }
    public void checkCreateClassLoader() { }
    public void checkAccess(Thread t) { }
    public void checkAccess(ThreadGroup g) { }
    public void checkExit(int status) { }
    public void checkExec(String cmd) { }
    public void checkLink(String lib) { }
    public void checkRead(FileDescriptor fd) { }
    public void checkRead(String file) { }
    public void checkRead(String file, Object context) { }
    public void checkWrite(FileDescriptor fd) { }
    public void checkWrite(String file) { }
    public void checkDelete(String file) { }
    public void checkConnect(String host, int port) { }
    public void checkConnect(String host, int port, Object context) { }
    public void checkListen(int port) { }
    public void checkAccept(String host, int port) { }
    public void checkMulticast(InetAddress maddr) { }
    public void checkMulticast(InetAddress maddr, byte ttl) { }
    public void checkPropertiesAccess() { }
    public void checkPropertyAccess(String key) { }
    public boolean checkTopLevelWindow(Object window) { return true; }
    public void checkPrintJobAccess() { }
    public void checkSystemClipboardAccess() { }
    public void checkAwtEventQueueAccess() { }
    public void checkPackageAccess(String pkg) { }
    public void checkPackageDefinition(String pkg) { }
    public void checkSetFactory() { }
    public void checkMemberAccess(Class clazz, int which) { }
    public void checkSecurityAccess(String target) { }
}
