/*
   STServiceRegistration.java

   Copyright (C) 2000 by ted stockwell
   All Rights Reserved.
 */
package org.servicetango.core;

import org.osgi.framework.*;
import java.util.*;
import java.io.*;

/**
 *  @author   ted stockwell [emorning@mediaone.net]
 */
public class STServiceRegistration
implements ServiceRegistration, Serializable
{
  STServiceReference m_reference;

  public STServiceRegistration(STServiceReference reference)
  {
    m_reference= reference;
  }

  /**
   * Unregisters the associated service
   * If a bundle wants to keep its service registered, it should keep the
   * ServiceRegistration object referenced.
   */
  protected void finalize()
  throws Throwable
  {
    try {
        unregister();
    }
    catch (Throwable t) {
    }
    super.finalize();
  }

    public ServiceReference getReference() {
        return m_reference;
    }
    public void setProperties(Dictionary p0) {
        m_reference.setProperties(p0);
    }
    public void unregister() {
        m_reference.getBundleManager().unregisterService(this);
    }
}
