package org.servicetango.service.http;

import java.util.*;
import java.net.*;
import java.io.*;
import java.security.*;
import javax.servlet.*;
import org.apache.tomcat.startup.*;

import org.osgi.service.http.*;

import org.apache.tomcat.core.*;
import org.apache.tomcat.request.*;
import org.apache.tomcat.service.*;
import org.apache.tomcat.service.http.*;
import org.apache.tomcat.session.StandardSessionInterceptor;
import org.apache.tomcat.context.*;

public class STContext
extends Context
{
    HttpContext m_httpcontext;

    class STFileNameMap
    implements FileNameMap
    {
        Map m_more= new HashMap();
        public String getContentTypeFor(String fileName) {
            String type= (String)m_more.get(fileName);
            if (type == null  ||  type.length() <= 0)
              type= m_httpcontext.getMimeType(fileName);
            return type;
        }
        public void addContentType(String fileName, String type) {
          m_more.put(fileName, type);
        }
    };
    STFileNameMap m_mimemap= new STFileNameMap();

    /**
     * Creates a Tomcat context for servlets.
     */
    STContext(ContextManager contextManage, String alias, Dictionary initParams, final HttpContext httpcontext) {
        init(contextManage, alias, httpcontext);

        for (Enumeration e= initParams.keys(); e.hasMoreElements();) {
            String key= e.nextElement().toString();
            String value= initParams.get(key).toString();
            addInitParameter(key, value);
        }
    }
    /**
     * Creates a Tomcat context for resources.
     */
    STContext(ContextManager contextManage, String alias, String name, HttpContext httpcontext) {
        init(contextManage, alias, httpcontext);
    }

    void init(ContextManager contextManager, String alias, final HttpContext httpcontext) {
        m_httpcontext= httpcontext;
        setContextManager(contextManager);
        setPath(alias);
        setDocBase("");
    }

    public FileNameMap getMimeMap() {
        return m_mimemap;
    }

    public void addContentType(String ext, String type) {
	m_mimemap.addContentType(ext, type);
    }


    // -------------------- Mappings --------------------

    /** Implements getResource()
     *  See getRealPath(), it have to be local to the current Context -
     *  and can't go to a sub-context. That means we don't need any overhead.
     */
    public URL getResource(String rpath)
    throws MalformedURLException
    {
      return m_httpcontext.getResource(rpath);
    }


    /*
    Why is super.log(String msg) a final method???

    public void log(String msg) {
        if (0 < getDebug())
            super.log(msg);
    }
    */
    public void log(String msg, Throwable t) {
        if (0 < getDebug())
            super.log(msg, t);
    }
    public void log(String msg, Throwable t, int level) {
        if (0 < getDebug())
            super.log(msg, t, level);
    }
    public void logServlet( String msg , Throwable t ) {
        if (0 < getDebug())
            super.logServlet( msg , t );
    }
}
