/*
   STServletException.java

   Copyright (C) 2000 by ted stockwell
   All Rights Reserved.
 */
package org.servicetango.service.http;

import javax.servlet.*;
import java.io.*;

/**
 *  For wrapping ServletExceptions
 *
 *  @author     ted stockwell [emorning@mediaone.net]
 *  @version    $Revision$
 */
public class STServletException
extends ServletException
implements Serializable
{
    /**
     *  Constructs an <code>Exception</code> with no specified detail
     *  message.
     */
    public STServletException() {
	    super("");
    }

    /**
     *  Constructs an <code>Exception</code> with the specified detail
     *  message.
     *
     *  @param   s   the detail message.
     */
    public STServletException(String s) {
	    super(s);
    }

    public Throwable detail;

    public STServletException(String s, Throwable ex) {
	super(s);
	detail = ex;
    }
    public STServletException(Throwable ex) {
        super("");
	detail = ex;
    }

    public String getMessage() {
	if (detail == null)
	    return super.getMessage();
	else
	    return super.getMessage() +
		"; nested exception is: \n\t" +
		detail.toString();
    }

    public void printStackTrace(java.io.PrintStream ps)
    {
	if (detail == null) {
	    super.printStackTrace(ps);
	} else {
	    synchronized(ps) {
		ps.println(this);
		detail.printStackTrace(ps);
	    }
	}
    }

    public void printStackTrace()
    {
	printStackTrace(System.err);
    }

    public void printStackTrace(java.io.PrintWriter pw)
    {
	if (detail == null) {
	    super.printStackTrace(pw);
	} else {
	    synchronized(pw) {
		pw.println(this);
		detail.printStackTrace(pw);
	    }
	}
    }
}
