package org.servicetango.service.log;

import java.util.*;
import org.osgi.framework.*;

public class LogActivator
implements BundleActivator
{

    public void start(BundleContext bundlecontext)
    throws BundleException
    {
        logListeners = new LogListeners();
        Log log = new Log(size, logListeners);
        LogServiceFactory logservicefactory = new LogServiceFactory(log);
        Hashtable hashtable = new Hashtable(1);
        hashtable.put("Description", "The standard ServiceTango Log service");
        logServiceReg = bundlecontext.registerService("org.osgi.service.log.LogService", logservicefactory, hashtable);
        LogReaderServiceFactory logreaderservicefactory = new LogReaderServiceFactory(log, logListeners);
        Hashtable hashtable1 = new Hashtable(1);
        hashtable1.put("Description", "The standard ServiceTango LogReader service");
        logReaderServiceReg = bundlecontext.registerService("org.osgi.service.log.LogReaderService", logreaderservicefactory, hashtable1);
        bundlecontext.addBundleListener(new BundleListener() {
            public void bundleChanged(BundleEvent bundleevent) {
                if(bundleevent.getType() == 4 && logListeners != null)
                    logListeners.remove(bundleevent.getBundle());
            }

        });
    }

    public void stop(BundleContext bundlecontext)
    throws BundleException
    {
        if(logServiceReg != null)
            logServiceReg.unregister();
        if(logReaderServiceReg != null)
            logReaderServiceReg.unregister();
    }

    public LogActivator() {
        String s = System.getProperty("com.sun.jes.service.log.size");
        try {
            if(s != null)
                size = Integer.parseInt(s);
        }
        catch(NumberFormatException _ex) { }
        logServiceReg = null;
        logReaderServiceReg = null;
        logListeners = null;
    }

    private static final int defaultSize = 20;
    private static int size = 20;
    private ServiceRegistration logServiceReg;
    private ServiceRegistration logReaderServiceReg;
    private LogListeners logListeners;
}
