package org.servicetango.service.log;

import java.util.*;
import org.osgi.framework.*;
import org.osgi.service.log.*;

class LogListeners
{

    public synchronized void add(LogListener loglistener, Bundle bundle) {
        listeners.addElement(loglistener);
        bundles.addElement(bundle);
    }

    public synchronized void remove(LogListener loglistener) {
        for(int i = 0; (i = listeners.indexOf(loglistener, i)) >= 0;)
            remove(i);
    }

    public synchronized void remove(Bundle bundle) {
        for(int i = 0; (i = bundles.indexOf(bundle, i)) >= 0;)
            remove(i);
    }

    private void remove(int i) {
        listeners.removeElementAt(i);
        bundles.removeElementAt(i);
    }

    public void notifyListeners(LogEntry logentry) {
        LogListener aloglistener[];
        synchronized(this) {
            aloglistener = new LogListener[listeners.size()];
            listeners.copyInto(aloglistener);
        }
        for(int i = 0; i < aloglistener.length; i++) {
            LogListener loglistener = (LogListener)aloglistener[i];
            loglistener.logged(logentry);
        }
    }

    LogListeners() {
        listeners = new Vector(5, 10);
        bundles = new Vector(5, 10);
    }

    private static final int initialCapacity = 5;
    private static final int expansionAmount = 10;
    Vector listeners;
    Vector bundles;
}
