package org.servicetango.service.log;

import org.osgi.framework.*;

class LogReaderServiceFactory
implements ServiceFactory
{

    LogReaderServiceFactory(Log log, LogListeners loglisteners) {
        m_log = log;
        m_logListeners = loglisteners;
    }

    public Object getService(Bundle bundle, ServiceRegistration registration) {
        return new LogReaderServiceImpl(m_log, m_logListeners, bundle);
    }

    public void ungetService(Bundle bundle, ServiceRegistration registration, Object obj) {
        m_logListeners.remove(bundle);
    }

    private Log m_log;
    private LogListeners m_logListeners;
}
