package org.servicetango.service.log;

import java.io.*;
import org.osgi.framework.*;
import org.osgi.service.log.LogService;

class LogServiceImpl
implements LogService, Configurable
{

    LogServiceImpl(Log log1, Bundle bundle) {
        m_log = log1;
        m_bundle = bundle;
    }

    public void log(int i, String s) {
        log(null, i, s, null);
    }

    public void log(int i, String s, Throwable throwable) {
        log(null, i, s, throwable);
    }

    public void log(ServiceReference servicereference, int i, String s) {
        log(servicereference, i, s, null);
    }

    public void log(ServiceReference servicereference, int i, String s, Throwable throwable) {
        m_log.add(m_bundle, servicereference, i, s, throwable);
    }

    public Object getConfigurationObject() {
        return new LogConfigurationObject(m_log);
    }

    private Log m_log;
    private Bundle m_bundle;
}
